/*
 * This file is part of queso.
 *
 * Copyright © 2020 Canek Peláez Valdés
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *    Canek Peláez Valdés <canek@ciencias.unam.mx>
 */

namespace Queso {

    /**
     * Class for the ''main()'' method.
     */
    public class ApplicationMain {

        public static int main(string[] args) {
            Gst.init(ref args);
            GLib.Intl.bindtextdomain(Config.GETTEXT_PACKAGE, Config.LOCALEDIR);
            GLib.Intl.bind_textdomain_codeset(Config.GETTEXT_PACKAGE, "UTF-8");
            GLib.Intl.textdomain(Config.GETTEXT_PACKAGE);
            GLib.Environment.set_application_name("Queso");

            // var v4lmgr = new V4LControlManager("/dev/video0");
            // for (int i = 0; i < v4lmgr.get_size(); i++) {
            //     unowned V4LControl v4lctrl = v4lmgr.nth_control(i);
            //     stderr.printf("%s:\n", v4lctrl.get_name());
            //     stderr.printf("\tType:    %s\n",
            //                   v4lctrl.get_type().to_string());
            //     stderr.printf("\tMinimum: %" + int64.FORMAT + "\n",
            //                   v4lctrl.get_minimum());
            //     stderr.printf("\tMaximum: %" + int64.FORMAT + "\n",
            //                   v4lctrl.get_maximum());
            //     stderr.printf("\tStep:    %" + uint64.FORMAT + "\n",
            //                   v4lctrl.get_step());
            //     stderr.printf("\tDefault: %" + int64.FORMAT + "\n",
            //                   v4lctrl.get_default_value());
            //     if (v4lctrl.get_type() == V4LControlType.MENU) {
            //         for (int j = 0; j < v4lctrl.get_menu_size(); j++) {
            //             unowned V4LControlMenuItem mi;
            //             mi = v4lctrl.nth_menu_item(j);
            //             if (mi.is_disabled())
            //                 continue;
            //             stderr.printf("\t\tMenu item %u: %s\n",
            //                           mi.get_index(),
            //                           mi.get_name());
            //         }
            //     }
            //     if (v4lctrl.get_type() == V4LControlType.INT_MENU) {
            //         for (int j = 0; j < v4lctrl.get_menu_size(); j++) {
            //             unowned V4LControlMenuItem mi;
            //             mi = v4lctrl.nth_menu_item(j);
            //             if (mi.is_disabled())
            //                 continue;
            //             stderr.printf("\t\tMenu item %u: %s\n",
            //                           mi.get_index(),
            //                           mi.get_name());
            //         }
            //     }
            // }

            var app = new Application();
            return app.run(args);
        }
    }
}
